main()
{
  maps\mp\mp_bitssd_fx::main();
  maps\mp\_load::main();
  maps\mp\mp_bits_fx::main();
  game["allies"] = "american";
  game["axis"] = "german";
  game["attackers"] = "allies";
  game["defenders"] = "axis";
  game["american_soldiertype"] = "normandy";
  game["german_soldiertype"] = "normandy";
  level.amb_sound[0] = "rain_no";
  level.amb_sound[1] = "rain_light";
  level.amb_sound[2] = "rain_hvy";
  level.rain[1] = loadfx ("fx/misc/rain_light.efx"); 
  level.rain[2] = loadfx ("fx/misc/rain_heavy.efx"); 
  level.weather = 0;
  level.lightning = loadfx ("fx/misc/lightning.efx");  
  level.mapheight = 450;
  level.mortar_rounds["allies"] = 20;
  level.mortar_rounds["axis"] = 20;
  level thread doorInit();
  level thread weather_effects();
  level thread rasta_cod2_rain(); 
  level thread lightning_and_thunder();
//  level thread show_location();
  level thread artyInit();
  level thread mortarInit();
//  spawn_AFOs();
  level thread radioInit();
  if(getcvar("g_gametype") == "hq")
  {
    rlist = getentarray("radiomodel","targetname");
    level.radio = [];
    for (i=0;i<rlist.size;i++) 
    {
      level.radio[i] = spawn("script_model",rlist[i].origin);
      level.radio[i].angles = rlist[i].angles;
    }
  }
}
weather_effects()
{
  while (1) 
  {
     if (level.weather<0) 
     {
       level.weather = 0;
     }
     if (level.weather>2) 
     {
       level.weather = 2;
     }
     if (level.weather==0) 
     {
//       iprintln("rain level is none");
       ambientPlay("rain_no");
     }
     else if (level.weather==1)
     {
//       iprintln("rain level is light");
       ambientPlay("rain_light");
     }
     else if (level.weather==2) 
     {
//       iprintln("rain level is heavy");
       ambientPlay("rain_hvy");
     }
     wait 30;
     stage_change = randomint(3)-1;
     level.weather += stage_change;
     if (level.weather<0) 
     {
       level.weather = 0;
     }
     if (level.weather>2) 
     {
       level.weather = 2;
     }
  }
}
mortarInit()
{
  level.spotpos["allies"] = (0,0,-100);
  level.spotpos["axis"] = (0,0,-100);
  mortar_trigs = getentarray("mortar_trig","targetname");
  for (i=0;i<mortar_trigs.size; i++) 
  {
    mortar_trigs[i] thread mortarThread();
  }
}
mortarThread()
{
  mortar = getent(self.target,"targetname");
  while(1)
  {
    self waittill("trigger",other);
    if (isPlayer(other) && (level.spotpos[other.pers["team"]]!= (0,0,-100))) {
      team = other.pers["team"];
      if (level.mortar_rounds[team]>0) 
      {
        level.mortar_rounds[team]--;
        mortar = getent(self.target,"targetname");
        mortar playsound ("mortar_launch"); 
        playfx(level._effect["mortar_flash"], mortar.origin); 
        wait 2;
        thread artyStrike(level.spotpos[team]);
        mortar playsound ("mortar_load");
        if (level.mortar_rounds[team]>0) 
        {
          other iprintln(team+" have "+level.mortar_rounds[team]+" mortar rounds left");
        }
      }
      else 
      {
        other iprintln("Sorry, your team is now out of ammo, consider throwing rocks instead.");
      }
    }
    else {
      if (isPlayer(other)) 
      {
        other iprintln("You need a spotter!");
      }
    }
  }
}
doorInit()
{
  door_trigs = getentarray("door_trigger","targetname");
  level.doors = [];
  for(i=0;i<door_trigs.size;i++)
  {
    door_trigs[i] thread doorThread();
  }
}


doorThread()
{
  door = getent(self.target,"targetname");
  level.doors[self.target] = "closed";
  while(1)
  {
    self waittill("trigger");
    door = getent(self.target,"targetname");
    if (level.doors[self.target]!="locked") 
    {
      door rotateYaw(-90, 1.5, 0.7, 0.7);
      door playsound ("door_open");
      door waittill("rotatedone");
      if (level.doors[self.target]!="locked")
        level.doors[self.target] = "open";
      wait 3;
      door rotateYaw(90, 1.5, 0.7, 0.7);
      door waittill("rotatedone");
      door playsound("door_close");
      if (level.doors[self.target]!="locked")
        level.doors[self.target] = "closed";
    }
    else
    {
      door playsound("door_locked");
    }
  }
}
lightning_and_thunder()
{
  while(1) 
  {
     delay = 10;
     if (level.weather==0)
     {
       delay = 30;
     }
     else if (level.weather==1)
     {
       delay = 15;
     }
     else if (level.weather==2) 
     {
       delay =  8;
     }
     wait delay;
//     loc = (-4515,-1661,750);   
     centerx = -2040;
     centery = 2616;
     diffx = (150-randomfloat(300))*10;
     diffy = (150-randomfloat(300))*10;
     x = centerx + diffx;
     y = centery + diffy;
//     x = (360-randomfloat(1000))*10;
//     y = (800-randomfloat(1600))*10;
     z = 750;
     soundz = 100;
     loc = (x,y,z);
     ent = spawn ("script_origin",loc);
//     iprintlnbold ("lightning!");
     maps\mp\_fx::oneshotfx ("lightning",ent.origin,0,ent.origin + (0,0,50));
//     iprintlnbold ("resulting thunder!");
//     ent.origin = (x,y,soundz);
     ent playsound ("nvthunder");
     wait 7;
     ent delete();
//     iprintlnbold ("done!");
//     ambientPlay(level.ambient);

  }
}
rasta_cod2_rain() 
{    
    zufall = RandomInt(100);        
            
    while(1) {
        
    
        players = getentarray("player", "classname");        
        wl = level.weather;
        
        if ((players.size > 0) && (wl>0)) {
        
            max_nodes         = 10;
            max_nodes_per_player     = max_nodes/players.size;
        
        
            for(ii=0;ii<max_nodes_per_player;ii++) {             
                for(i = 0; i < players.size; i++) {
                        
                    player = players[i];

                    if(isAlive(player)) {

                      x= 350-randomfloat(700);
                      y= 350-randomfloat(700);
                      start = player.origin+(x,y,level.mapheight);
//                        pos = player.origin +(x,y,200) ;                        
                      pos = physicstrace(start,start+(0,0,-1*level.mapheight));                
//                      trace = bulletTrace(pos,pos +(0,0,-250), true, undefined);
                      
                      playfx(level.rain[wl],pos+(0,0,level.mapheight));
//                      if(trace["fraction"] != 1) playfx(level.rain,trace["position"]);                
                      wait 0.05;
                                              
                   }                        
                }
            }                    
        }
        
        wait 0.05;
    }    
}
show_location() 
{
  while (true)
  {
    players = getentarray("player", "classname");        
    numplayers = players.size;
    for (i=0;i<numplayers;i++) 
    {
      players[i] iprintln("Current location is "+players[i].origin);
    }
    wait 5;
  }
}
artyInit()
{
  diffx = 2000;
  diffy = 2000;
  startx = 0;
  starty = 0;
  z = 300;
  while (1) {
    wait 10;
    x = startx + randomint(diffx*2)-diffx;
    y = starty + randomint(diffy*2)-diffy;
    loc = (x, y, z);
    artyBarrage(loc);
    wait 10;
  }
}
artyBarrage(pos)
{
   wait 60;
   ent = spawn("script_origin",pos);
   playfx(level._effect["arty_marker"],ent.origin);
   wait 5;
   marker_loc = ent.origin;
   ent playsound("distant_artillery_barrage1");
   wait 2;
   for (i=1;i<=6;i++) {
     thread artyStrike(ent.origin);
   }
   ent delete();

}
spotterRound(pos)
{
   wait 0.5;
   playfx(level._effect["arty_marker"],pos+(0,0,300));
   wait 5;

}
artyStrike(pos) 
{
   ent = spawn("script_origin",pos);
   wait 1+randomint(6);
   xdiff = randomint(1000)-500;
   ydiff = randomint(1000)-500;
   ent.origin = ent.origin + (xdiff, ydiff,0);
   ent.origin = physicstrace(ent.origin,ent.origin + (0,0,-1500));
   ent playsound("shell_incoming2");
   wait 2;
   playfx(level._effect["arty_strike"],ent.origin);
   wait 0.05;
   radiusDamage(ent.origin, 800, 4000, 50);
   wait 0.05;
   earthquake(0.4, 4, ent.origin, 1000);
   wait 0.05;
   ent playsound("artillery_impact");
   ent delete();
}
radioInit()
{
// each side gets to have one arty strike at a time in use
  level.artillery_inuse["axis"] = false;
  level.artillery_inuse["allies"] = false;

//foreach trigger radius, thread the activation function
  radio_trigs = getentarray("radio_trig","targetname");
 
  for(i=0;i<radio_trigs.size;i++)
  {
    radio_trigs[i] thread radioThink(i);
  }
}
trig_message_relay(message,e,trig)
{
  self endon (e);
  loopvar = true;
  msg_count = 0;
  self iprintln(message);
  while (loopvar)
  {
    if (!self istouching(trig))
    {
      loopvar = false;
    }
    else
    {
      msg_count++;
      if (msg_count>100)
      {
        self iprintln(message);
        msg_count = 0;
      }
    }
    wait 0.05;
  }
}
away_from_radio(other,i)
{
  level.radio_inuse[i]= true;
  while (other istouching(self))
  {
    wait 0.5;
  }
  level.radio_inuse[i]= false;
  other iprintln("lost radio contact");
  self notify("away_from_radio");
}
radioInUse(i,other)
{
  self endon("away_from_radio");
  other iprintln("you have radio contact");
  if (level.radio_inuse[i]==false)
  {
    self thread away_from_radio(other,i);
    while (isalive(other))
    {
// wait till player uses binocs
      other thread trig_message_relay("use binoculars to spot for mortars","binocular_enter",self);
      other waittill("binocular_enter");
// monitor for the USE button
      thread monitorUseButton(other,self);
      other thread trig_message_relay("press USE to call to spot for mortars","binocular_exit",self);
      other waittill("binocular_exit");
    }
    wait 0.05;
  }
}
radioThink(i)
{
// only one person at a time can use a radio
  level.radio_inuse[i] = false;

  while (1)
  {
// wait until someone walking into the radius of a trigger
    self waittill("trigger",other);
    if (isPlayer(other)) {
      self radioInUse(i,other);
    }
    wait 0.05;
  }
}
vector_scale (vec, scale)
{
  vec = (vec[0] * scale, vec[1] * scale, vec[2] * scale);
  return vec;
}
monitorUseButton(other,trig)
{
  other endon ("binocular_exit");
  trig endon ("away_from_radio");
  loopvar = true;
  count = 0;
//  iprintln("monitoring active");
  msg = true;
  while (loopvar)
  {
    if (!isalive(other))
    {
      loopvar = false;
    }
    if (other usebuttonpressed())
    {
      if (level.artillery_inuse[other.pers["team"]] == false)
      {
        other iprintln("Request received, firing spotting round");

        if(isdefined(other.ex_eyemarker))
        {
          other.ex_eyemarker unlink();
          other.ex_eyemarker delete();
        }
        other.ex_eyemarker = spawn("script_origin",(0,0,0));
        other.ex_eyemarker linkto (other, "tag_eye",(0,0,0),(0,0,0));
        wait 0.05;
        startOrigin = other.ex_eyemarker.origin;

//        startOrigin = other getEye();
// this code basicly draws a line from the players eyes, to where the arty strike is supposed to be centered
        forward = anglesToForward( other getplayerangles() );
        forward = vector_scale( forward, 100000 );
        endOrigin = startOrigin + forward;
        trace = bulletTrace( startOrigin, endOrigin, false, other);
// set it so that the team's artillery is temporarily unavailable
        level.artillery_inuse[other.pers["team"]] = true;
// thread the arty strike
        level.spotpos[other.pers["team"]] = trace["position"];
        thread spotterRound(trace["position"]);
// thread the reload
        thread artyreload(other.pers["team"]);
        loopvar = false;
      }
      else
      {
        if (msg)
          other iprintln("Request denied -- battery in use, or reloading");
        msg = false;
      }
    }
    wait 0.05;
  }
}
artyreload(team)
{

// if the reload delay not defined, then define it to 2 mins
  if (!isdefined(level.arty_reload_delay))
    level.arty_reload_delay = 20;
  wait level.arty_reload_delay;
//reset the team's artillery use
  level.artillery_inuse[team] = false;
  iprintln(team+" spotting is available");
}

spawn_AFOs() 
{
  precacheModel("xmodel/military_german_radio1_green");
  level.radioloc[0] = (716,-569,280);
  level.radioloc[1] = (-1416,743,300);
  level.radioloc[2] = (275,1158,282);
  level.radioloc[3] = (704,485,306);
  for (i=0;i<level.radioloc.size;i++) 
  {
    level.radiomod[i] = spawn("script_model", level.radioloc[i]);
    wait 0.05;
    level.radiomod[i] setmodel("xmodel/military_german_radio1_green");
    level.radiotrig[i] = spawn("trigger_radius", level.radioloc[i],0,45,72);
    wait 0.05;
    level.radiotrig[i].targetname = "radio_trig";
    level.radiotrig[i].hintstring = "use binoculars to spot for mortars";
  }
}